#WBL 20 Feb 2007, 

#WBL 30 Jun 2008 Add Copyright notice
#WBL 30 Oct 2007 Replace @exprs by exprs()
#WBL  2 Oct 2007 Build on r1.20, use quantilebyrow
#WBL  8 Mar 2007 Gather stats on probe variation (ok cal is slow)
#WBL  7 Mar 2007 mean of all (inc suspect probes) for quantile normalisation
#WBL  5 Mar 2007 
#WBL 26 Feb 2007 stream line for batch use
#regress test4.R from test3.R restore min, start ids at 1

cat("Code supplied with TCBB-2007-11-0161 and for no other purpose.\n");
args=commandArgs()
cat("idf_flaws $Revision: 1.26 $",date(),args[4],args[5],args[6],args[7],"\n");
source("cmdline.R");
source("average.R");
source("impf.R");

cmd   = cmdline(args);
all1  = cmd$files;
output= cmd$output;

cat("establishing background ",output,"\n");
stats = average_all_cel(all1,output);
rm(Sorted);
normean = exp(stats$lgmean);
type=stats$annotation;
all =stats$files;

qdistribution = sortbyrow(normean);

R <- 2;
S<-sqrt(length(normean));

## VARIABLES FOR CALCULATION OF C AND N MATRIXES
dd=as.integer(S/3)*3;
dd2=dd/3;
dc=as.integer(S/5)*5;
dc2=dc/5;

idf  = array(0,dim=c(dd2,dd2));
idfm = array(0,dim=c(dd2,dd2));
idfa = 0; #number whole CELs discarded
sum  = array(0,dim=c(S,S));
sum2 = array(0,dim=c(S,S));
count= array(0,dim=c(S,S));

#map from dd2,dd2 back to S,S
P=array(NA,dim=S); for(i in seq(1:(dd2*3))){P[i]=1+as.integer((i-1)/3);}
idf_flaws_init(dd2);

cat("Comparing ",length(all)," files with background\n",date(),"\n",sep="");
for(f in 1:length(all)) {
  a <- ReadAffy(filenames=all[f],sd=FALSE);

 ## GIVE THE NAME OF THE CEL FILES
  if(type!=a@annotation) {
    print(paste("ERROR type mismatch",type,f,all[f],a@annotation));
    exit(0);
  } else if((S*S)!=length(exprs(a))) {
    print(paste("ERROR length mismatch",S*S,f,all[f],length(exprs(a))));
    exit(0);
  }
  mat <- quantilebyrow(array(exprs(a),dim=c(S,S)),qdistribution);

#require all 4 corners to agree with centre
#require at least 2 of eight neighbouring 3x3 to agree (and have reached pid)
pid=4;threshold=2;

graf  = idf_flaws(pid,threshold,(normean<mat)); #ids_max
grafm = idf_flaws(pid,threshold,(normean>mat)); #ids_min

## create the OK matrix
  ok = array(1,dim=c(S,S)) - graf[P,P] - grafm[P,P];
  ok[which(is.na(ok))]=1;

if(min(ok)<0) {#sanity check
  print(paste("ERROR both too low and too high",type,f,all[f]));
  exit(0);
}

w=length(which(ok==0));
summary=paste(all[f],paste("pid=",pid," thd=",threshold,sep=""),
	    "idf suspect probes",w,paste(round(100*w/(S*S)),"%",sep=""));
cat(summary,date(),"",sep="\n");

#x=(graf>0)-(grafm>0);
#image(x[ ,ncol(x):1 ],col=c(1,0,2)); #black,white,red
#title(summary,cex.main = 1.1)

idf  = idf +graf;
idfm = idfm+grafm;
if(w>0.1*S*S) {idfa = idfa+1;} #discard whole CEL
else {
  d = mat-normean
  okd = ok*d;
  sum = sum + okd;
  sum2 = sum2 + okd*d;
  count = count + ok;
}
}#endfor all f
cat("Done",date(),"",sep="\n");

mean = normean+(sum/count);
sd   = sqrt((sum2/count) - (mean-normean)^2);

Cels = length(all)-idfa;

params = paste("wbl_idf_flaws.R $Revision: 1.26 $ pid=",pid," thd=",threshold,
               sep="");
files=""; for(f in 1:length(all)) {files=paste(files,all[f]);}
textfile = function(mat,name,file) {
  file=paste(output,file,sep="");
  write(paste("#",params,length(mat),date(),S,dd2,name,type,length(all),files),
        file=file);
  write(mat, file=file, ncolumns=1,append=TRUE);
}
textfile(idf, "idf", file="idf.txt" );
textfile(idfm,"idfm",file="idfm.txt" );
#The following can be saved but values produced by average.R are more useful
#textfile(mean,"mean",file="mean.txt" );
#textfile(sd,  "sd",  file="sd.txt" );

cat(paste("Summary",type,date(),length(all1),length(all),idfa,Cels,
     "ovr",round(mean(idf ),3),paste(round(100*mean(idf )/Cels,1),"%",sep=""),
     "udr",round(mean(idfm),3),paste(round(100*mean(idfm)/Cels,1),"%",sep=""),
     "\n"));

#exit(); #################################################################
#
#The following make nice pictures but are more suited to interactive
#R use than batch mode. Feel free to uncomment
#
#summary=paste(length(all),type,paste("pid=",pid," thd=",threshold,sep=""),
#	    "idf (ovr) suspect probes",paste(round(100*mean(idf)/Cels),"%",sep=""));
#cat(summary,date(),"",sep="\n");
#image(idf[ ,ncol(idf):1 ]) #,col=c(1,0,2)); #black,white,red
#title(paste(summary,date()),cex.main = 1.1);
#
#summary=paste(length(all),type,paste("pid=",pid," thd=",threshold,sep=""),
#	    "idf (udr) suspect probes",paste(round(100*mean(idfm)/Cels),"%",sep=""));
#cat(summary,date(),"",sep="\n");
#image(idfm[ ,ncol(idfm):1 ]) #,col=c(1,0,2)); #black,white,red
#title(paste(summary,date()),cex.main = 1.1);
#
#cat(paste(idfa,"CELs of",length(all),"rejected"),"",sep="\n");
#
#m=mean((mean-normean)[which(count>0)]);
#summary=paste(length(all),type,paste("pid=",pid," thd=",threshold,sep=""),
#              "Difference from normean",round(m,3));
#cat(summary,date(),"",sep="\n");
#image(sign(mean-normean)*log(abs(mean-normean))[ ,ncol(mean):1 ]) 
#title(paste(summary,date()),cex.main = 1.1);
#
#summary=paste(length(all),type,paste("pid=",pid," thd=",threshold,sep=""),
#	    "log Std Dev",round(mean(sd[which(count>0)]),3));
#cat(summary,date(),"",sep="\n");
#image(log(sd[ ,ncol(sd):1 ])) 
#title(paste(summary,date()),cex.main = 1.1);

